HDU 4632 Palindrome subsequence(区间dp)

Palindrome subsequence

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65535 K (Java/Others)
Total Submission(s): 2595    Accepted Submission(s): 1039


Problem Description
In mathematics, a subsequence is a sequence that can be derived from another sequence by deleting some elements without changing the order of the remaining elements. For example, the sequence <A, B, D> is a subsequence of <A, B, C, D, E, F>.
(http://en.wikipedia.org/wiki/Subsequence)

Given a string S, your task is to find out how many different subsequence of S is palindrome. Note that for any two subsequence X = <Sx1, Sx2, ..., Sxk> and Y = <Sy1, Sy2, ..., Syk> , if there exist an integer i (1<=i<=k) such that xi != yi, the subsequence X and Y should be consider different even if Sxi = Syi. Also two subsequences with different length should be considered different.
 

Input
The first line contains only one integer T (T<=50), which is the number of test cases. Each test case contains a string S, the length of S is not greater than 1000 and only contains lowercase letters.
 

Output
For each test case, output the case number first, then output the number of different subsequence of the given string, the answer should be module 10007.
 

Sample Input
4 a aaaaa goodafternooneveryone welcometoooxxourproblems
 

Sample Output
Case 1: 1 Case 2: 31 Case 3: 421 Case 4: 960
 

Source
 




/*
题意:问一个字符串的会问序列有多少个
    dp[i][j]=(dp[i][j-1]+dp[i+1][j]-dp[i+1][j-1]);
    if(c[i]==c[j]) 那么加上中间的dp[i+1][j-1],由于能够和i,j形成新的
    还要加上  1  (i 和  j 形成字符串)


*/

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<queue>
#include<stack>
#include<vector>
#include<set>
#include<map>

#define L(x) (x<<1)
#define R(x) (x<<1|1)
#define MID(x,y) ((x+y)>>1)

#define bug printf("hihi
")

#define eps 1e-8
typedef __int64 ll;

using namespace std;

#define mod 10007
#define INF 0x3f3f3f3f
#define N 1005

int dp[N][N];
int len;
char c[N];

int main()
{
   int i,j,t,ca=0;
   scanf("%d",&t);
   while(t--)
   {
       scanf("%s",c);
       len=strlen(c);
       memset(dp,0,sizeof(dp));
       for(i=0;i<len;i++)
          dp[i][i]=1;

       for(i=len-1;i>=0;i--)
         for(j=i+1;j<len;j++)
         {
            dp[i][j]=(dp[i+1][j]+dp[i][j-1]-dp[i+1][j-1]+mod)%mod;
            if(c[i]==c[j])
                dp[i][j]=(dp[i][j]+dp[i+1][j-1]+1+mod)%mod;
         }
         printf("Case %d: %d
",++ca,(dp[0][len-1]+mod)%mod);
   }
   return 0;
}


原文地址:https://www.cnblogs.com/yxysuanfa/p/7268799.html